<?
	class ListDataBase
	{
		var $id;
		
		var $list;
		var $data;
		
		function ListDataBase($id)
		{
			$this->id = $id;
			
			$this->list = new LinkList("./system/list/$this->id");
			$this->data = new DataFile("./system/data/$this->id");
		}
		
		function Open()
		{
			$list = $this->list;
			$check = $list->open();
			$this->list = $list;
			return $check;
		}
		
		function Close()
		{
			$list = $this->list;
			$list->close();
			$this->list = $list;
		}
		
		function Create()
		{
			$list = $this->list;
			$list->create();
		}
		
		function NewAdd()
		{
			$list=$this->list;
			$n=$list->Add();
			$this->list = $list;
			return $n;
		}
		
		function NewInsert($psN)
		{
			$list=$this->list;
			$n=$list->Insert($psN);
			$this->list = $list;
			return $n;
		}
		
		function Delete($n)
		{
			if ($n != 0 )
			{
				$list=$this->list;
				$list->Delete($n);;
				$this->list = $list;
			}
			unlink("./system/data/$this->id.$n.php");
			if (file_exists("./system/data/$this->id.$n.ment.php")) unlink("./system/data/$this->id.$n.ment.php");
			if (file_exists("./system/data/$this->id.$n.file.php")) unlink("./system/data/$this->id.$n.file.php");
		}
		
		function Put($no, $BUF)
		{
			$data = $this->data;
			$num = count($BUF);
			return $data->SaveData($no, $BUF, $num);
		}
		
		function Get($no)
		{
			$data = $this->data;
			list($BUF, $num) = $data->LoadData($no);
			return array($BUF, $num);
		}
		
		function GetValue($BUF, $dn)
		{
			return $BUF[$dn];
		}
		
		function NextNo($n)
		{
			$list=$this->list;
			return $list->GetNext($n);
		}
		
		function BeforeNo($n)
		{
			$list=$this->list;
			return $list->GetBefore($n);
		}
		
		function LastNo()
		{
			$list=$this->list;
			return $list->GetLast();
		}
		
		function Totaldata()
		{
			$list=$this->list;
			return $list->GetTotal();
		}
		
		function Totalpage($onepagen)
		{
			$list=$this->list;
			$totaldata = $this->Totaldata();
			$totalpage = (int)($totaldata/$onepagen);
			if ( $totaldata%$onepagen != 0 ) $totalpage++;
			return $totalpage;
		}
		
		function MakeList($page, $onepagen)
		{
			$list=$this->list;
			
			$totaldata = $this->Totaldata();
			$totalpage = $this->Totalpage($onepagen);
			
			if ( $page == 0 || $page == "" ) $page=$totalpage;
			
			$START = ($totalpage-$page)*$onepagen;
			$endps = $totaldata-$START;
			
			$START_N = $list->GetNnd($endps);
			
			/* test code
			echo "\{test code}total=$totaldata/totalpage=$totalpage/nowpage=$page/start=$START/endps=$endps/start_n=$START_N/";
			*/
			$LIST[0] = $START_N;
			/* test code
			echo "<br>0=$LIST[0]/";
			*/
			for ( $i=1 ; $i < $onepagen ; $i++ )
			{
				$LIST[$i] = $list->GetBefore($LIST[$i-1]);
				/* test code
				echo "$i=$LIST[$i]/";
				*/
				if ( $LIST[$i] == 0 ) break;
			}
			
			return array($LIST, $totaldata, $totalpage);
		}
		
		function SearchList($page, $onepagen, $keyword, $where)
		{
			$list=$this->list;
			$data=$this->data;
			
			/*
			// $psinf="123#444#555...";
			if ( $psinf!="" )
			{
				$ps[0] = strtok($psinf, "#");
				$i=1;
				while($ps[$i-1]!="")
				{
					$ps[$i] = strtok();
					$i++;
				}
			}
			*/
			$no = $list->GetLast();
			$i=0;
			while ( $no != 0 )
			{
				list($Field, $fnum) = $this->Get($no);
				for($j=0; $j<$fnum; $j++)
				{
					$vn=strtok($Field[$j], "=");
					$$vn=strtok("");
				}
				
				$result1=strpos($$where[0], $keyword);
				$result2=strpos($$where[1], $keyword);
				$result3=strpos($$where[2], $keyword);
				
				if ( $result1!==false || $result2!==false || $result3!==false )
				{
					//echo "<font color='red'>insert($keyword)</font>";
					$LIST[] = $no;
					$i++;
				}
				$no = $list->GetBefore($no);
			}
			
			$totalpage = (int)($i/$onepagen);
			if ( $i%$onepagen != 0 ) $totalpage++;
			if ( $page == "" || $page == 0 ) $page = $totalpage;
			
			if ( $i!=0 ) $list=array_slice($LIST, ($totalpage-$page)*$onepagen, $onepagen);
			return array($list, $i, $totalpage);
		}
	}
?>
